window.Gleam.initSearch([{"doc":"lap","title":"lap","content":"# lap\n\n[![Package Version](https://img.shields.io/hexpm/v/lap)](https://hex.pm/packages/lap)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/lap/)\n\nQuick&#39;n dirty timing of your Gleam code.\n\n```sh\ngleam add lap\n```\n\n```gleam\nimport gleam/int\nimport gleam/io\nimport lap\n\npub fn main() {\n  let data = lap.start_in_milliseconds(&quot;1&quot;)\n\n  // Some work\n\n  let data = data |&gt; lap.time(&quot;2&quot;)\n\n  // Some work\n\n  let data = data |&gt; lap.time(&quot;3&quot;)\n\n  data |&gt; lap.intervals |&gt; io.debug\n  // [#(&quot;1&quot;, &quot;2&quot;, 10), #(&quot;2&quot;, &quot;3&quot;, 30)]\n\n  data |&gt; lap.sort_max |&gt; lap.pretty_print |&gt; io.println\n  // +-------+-----+----------+-------+\n  // | Start | End | Duration | %     |\n  // +-------+-----+----------+-------+\n  // | 2     | 3   | 30 ms    | 75.0  |\n  // | 1     | 2   | 10 ms    | 25.0  |\n  // +-------+-----+----------+-------+\n\n  data |&gt; lap.total_time |&gt; int.to_string |&gt; io.println\n  // 40\n}\n```\n","url":"index.html"},{"doc":"lap","title":"DurationData","content":"pub opaque type DurationData\n\n\nSynonyms:\nlap.DurationData\nlap DurationData","url":"lap.html#DurationData"},{"doc":"lap","title":"LapData","content":"pub opaque type LapData\n\n\nSynonyms:\nlap.LapData\nlap LapData","url":"lap.html#LapData"},{"doc":"lap","title":"pretty_print","content":"pub fn pretty_print(data: LapData) -&gt; String\n Returns a table of the durations as a string. The table includes the start\n and end markers, duration, and percentage of the total time.\nSynonyms:\nlap.pretty_print\nlap pretty_print","url":"lap.html#pretty_print"},{"doc":"lap","title":"sort_max","content":"pub fn sort_max(data: LapData) -&gt; LapData\n Sorts the durations in descending order. This is useful for identifying the\n slowest parts of your timed code.\nSynonyms:\nlap.sort_max\nlap sort_max","url":"lap.html#sort_max"},{"doc":"lap","title":"start","content":"pub fn start(marker: String, duration_unit: Unit) -&gt; LapData\n Begins a new timing session with the given marker and duration unit. The\n duration_unit is a [birl](https://hexdocs.pm/birl/) `Unit`.\nSynonyms:\nlap.start\nlap start","url":"lap.html#start"},{"doc":"lap","title":"start_in_microseconds","content":"pub fn start_in_microseconds(marker: String) -&gt; LapData\n Begins a new timing session with the given marker and duration unit in\n microseconds.\nSynonyms:\nlap.start_in_microseconds\nlap start_in_microseconds","url":"lap.html#start_in_microseconds"},{"doc":"lap","title":"start_in_milliseconds","content":"pub fn start_in_milliseconds(marker: String) -&gt; LapData\n Begins a new timing session with the given marker and duration unit in\n milliseconds.\nSynonyms:\nlap.start_in_milliseconds\nlap start_in_milliseconds","url":"lap.html#start_in_milliseconds"},{"doc":"lap","title":"start_in_minutes","content":"pub fn start_in_minutes(marker: String) -&gt; LapData\n Begins a new timing session with the given marker and duration unit in\n minutes.\nSynonyms:\nlap.start_in_minutes\nlap start_in_minutes","url":"lap.html#start_in_minutes"},{"doc":"lap","title":"start_in_seconds","content":"pub fn start_in_seconds(marker: String) -&gt; LapData\n Begins a new timing session with the given marker and duration unit in\n seconds.\nSynonyms:\nlap.start_in_seconds\nlap start_in_seconds","url":"lap.html#start_in_seconds"},{"doc":"lap","title":"time","content":"pub fn time(data: LapData, marker: String) -&gt; LapData\n Marks the end of the current lap with the given marker.\nSynonyms:\nlap.time\nlap time","url":"lap.html#time"},{"doc":"lap","title":"to_list","content":"pub fn to_list(data: LapData) -&gt; List(#(String, String, Int))\n Return the durations as a list of tuples. Each tuple contains:\n 1. The start marker (String)\n 2. The end marker (String)\n 3. The duration (Int) in the specified time unit\nSynonyms:\nlap.to_list\nlap to_list","url":"lap.html#to_list"},{"doc":"lap","title":"total_time","content":"pub fn total_time(data: LapData) -&gt; Int\n Returns the total time elapsed from the first marker to the last marker, in\n the duration unit specified via one of the start functions.\nSynonyms:\nlap.total_time\nlap total_time","url":"lap.html#total_time"},{"doc":"lap","title":"lap","content":"","url":"lap.html"}]);